<?php

namespace \Losc\CucmBundle\Model\Webservice\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for XCcdRequestingService StructType
 * @subpackage Structs
 */
class XCcdRequestingService extends AbstractStructBase
{
    /**
     * The name
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - maxLength: 50
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: false
     * @var string
     */
    public $name;
    /**
     * The description
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - maxLength: 50
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $description;
    /**
     * The isActivated
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * - pattern: (t)|(f)|(true)|(false)|(0)|(1)
     * @var string
     */
    public $isActivated;
    /**
     * The routePartitionName
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: true
     * @var \\Losc\CucmBundle\Model\Webservice\StructType\XFkType
     */
    public $routePartitionName;
    /**
     * The learnedPatternPrefix
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - maxLength: 50
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $learnedPatternPrefix;
    /**
     * The pstnPrefix
     * Meta information extracted from the WSDL
     * - base: xsd:string
     * - maxLength: 50
     * - maxOccurs: 1
     * - minOccurs: 0
     * - nillable: false
     * @var string
     */
    public $pstnPrefix;
    /**
     * The associatedTrunks
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \\Losc\CucmBundle\Model\Webservice\StructType\AssociatedTrunks
     */
    public $associatedTrunks;
    /**
     * Constructor method for XCcdRequestingService
     * @uses XCcdRequestingService::setName()
     * @uses XCcdRequestingService::setDescription()
     * @uses XCcdRequestingService::setIsActivated()
     * @uses XCcdRequestingService::setRoutePartitionName()
     * @uses XCcdRequestingService::setLearnedPatternPrefix()
     * @uses XCcdRequestingService::setPstnPrefix()
     * @uses XCcdRequestingService::setAssociatedTrunks()
     * @param string $name
     * @param string $description
     * @param string $isActivated
     * @param \\Losc\CucmBundle\Model\Webservice\StructType\XFkType $routePartitionName
     * @param string $learnedPatternPrefix
     * @param string $pstnPrefix
     * @param \\Losc\CucmBundle\Model\Webservice\StructType\AssociatedTrunks $associatedTrunks
     */
    public function __construct($name = null, $description = null, $isActivated = null, \\Losc\CucmBundle\Model\Webservice\StructType\XFkType $routePartitionName = null, $learnedPatternPrefix = null, $pstnPrefix = null, \\Losc\CucmBundle\Model\Webservice\StructType\AssociatedTrunks $associatedTrunks = null)
    {
        $this
            ->setName($name)
            ->setDescription($description)
            ->setIsActivated($isActivated)
            ->setRoutePartitionName($routePartitionName)
            ->setLearnedPatternPrefix($learnedPatternPrefix)
            ->setPstnPrefix($pstnPrefix)
            ->setAssociatedTrunks($associatedTrunks);
    }
    /**
     * Get name value
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }
    /**
     * Set name value
     * @param string $name
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\XCcdRequestingService
     */
    public function setName($name = null)
    {
        $this->name = $name;
        return $this;
    }
    /**
     * Get description value
     * @return string|null
     */
    public function getDescription()
    {
        return $this->description;
    }
    /**
     * Set description value
     * @param string $description
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\XCcdRequestingService
     */
    public function setDescription($description = null)
    {
        $this->description = $description;
        return $this;
    }
    /**
     * Get isActivated value
     * @return string|null
     */
    public function getIsActivated()
    {
        return $this->isActivated;
    }
    /**
     * Set isActivated value
     * @param string $isActivated
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\XCcdRequestingService
     */
    public function setIsActivated($isActivated = null)
    {
        $this->isActivated = $isActivated;
        return $this;
    }
    /**
     * Get routePartitionName value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\XFkType|null
     */
    public function getRoutePartitionName()
    {
        return isset($this->routePartitionName) ? $this->routePartitionName : null;
    }
    /**
     * Set routePartitionName value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param \\Losc\CucmBundle\Model\Webservice\StructType\XFkType $routePartitionName
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\XCcdRequestingService
     */
    public function setRoutePartitionName(\\Losc\CucmBundle\Model\Webservice\StructType\XFkType $routePartitionName = null)
    {
        if (is_null($routePartitionName) || (is_array($routePartitionName) && empty($routePartitionName))) {
            unset($this->routePartitionName);
        } else {
            $this->routePartitionName = $routePartitionName;
        }
        return $this;
    }
    /**
     * Get learnedPatternPrefix value
     * @return string|null
     */
    public function getLearnedPatternPrefix()
    {
        return $this->learnedPatternPrefix;
    }
    /**
     * Set learnedPatternPrefix value
     * @param string $learnedPatternPrefix
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\XCcdRequestingService
     */
    public function setLearnedPatternPrefix($learnedPatternPrefix = null)
    {
        $this->learnedPatternPrefix = $learnedPatternPrefix;
        return $this;
    }
    /**
     * Get pstnPrefix value
     * @return string|null
     */
    public function getPstnPrefix()
    {
        return $this->pstnPrefix;
    }
    /**
     * Set pstnPrefix value
     * @param string $pstnPrefix
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\XCcdRequestingService
     */
    public function setPstnPrefix($pstnPrefix = null)
    {
        $this->pstnPrefix = $pstnPrefix;
        return $this;
    }
    /**
     * Get associatedTrunks value
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\AssociatedTrunks|null
     */
    public function getAssociatedTrunks()
    {
        return $this->associatedTrunks;
    }
    /**
     * Set associatedTrunks value
     * @param \\Losc\CucmBundle\Model\Webservice\StructType\AssociatedTrunks $associatedTrunks
     * @return \\Losc\CucmBundle\Model\Webservice\StructType\XCcdRequestingService
     */
    public function setAssociatedTrunks(\\Losc\CucmBundle\Model\Webservice\StructType\AssociatedTrunks $associatedTrunks = null)
    {
        $this->associatedTrunks = $associatedTrunks;
        return $this;
    }
}
